// Code scaffolded by goctl. Safe to edit.
// goctl 1.9.2

package verification_admin

import (
	"context"
	"juwan-backend/app/user_verifications/rpc/pb"
	"juwan-backend/common/utils/contextj"
	"time"

	"juwan-backend/app/users/api/internal/svc"
	"juwan-backend/app/users/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ApproveVerificationLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

// 管理员通过申请
func NewApproveVerificationLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ApproveVerificationLogic {
	return &ApproveVerificationLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

var (
	APPROVE = "approved"
)

func (l *ApproveVerificationLogic) ApproveVerification(req *types.VerificationIdReq) (resp *types.VerificationEmptyResp, err error) {
	adminId, err := contextj.AdminIdFrom(l.ctx)
	if err != nil {
		return nil, err
	}
	_, err = l.svcCtx.UserVerificationsRpc.UpdateUserVerifications(l.ctx, &pb.UpdateUserVerificationsReq{
		Id:         req.Id,
		Status:     &APPROVE,
		ReviewedBy: adminId,
		ReviewedAt: time.Now().Unix(),
	})
	if err != nil {
		return nil, err
	}
	return
}
